﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Diagnostics;

namespace RCVisualRX
{
   
    
    public partial class Form1 : Form
    {

        static byte Nbit = 8;                                   // pocet bitu (tlacitek)
        static byte MbuffSize = 6;                              // pocet byty zpravy
        static byte incBuffSize = 10;                           // delka prichoziho bufferu
        public bool[] btnArray = new bool[Nbit];                // pole bitu (tlacitek)
        public byte[] MBuffer = new byte[MbuffSize];            // buffer zpravy
        public bool zachycenStart = false;
        public byte[] incSerialBuffer = new byte[incBuffSize];  // prichozi buffer
        public int bufferIndex = 0;                             // index v bufferu zprav
        string dataString;
        string voltage;
        
        public Form1()
        {
            InitializeComponent();
        }

        // pocatecni akce po nahrani formulare
        private void Form1_Load(object sender, EventArgs e)
        {
            // po načtení formuláře, aktualizuje sériové porty
            comboBox1.Items.Clear();
            comboBox1.Items.AddRange(SerialPort.GetPortNames());
            if (comboBox1.Items.Count > 0) comboBox1.Text = comboBox1.Items[0].ToString();

            // vynuluje pole tlacitek
            int cnt = 0;
            foreach (bool a in btnArray)
                btnArray[cnt++] = false;

            // vynuluje index bufferu
            bufferIndex = 0;
            
        }

        // obsluha tlacitka pro otevreni a zavreni spojeni
        private void OCbtn_Click(object sender, EventArgs e)
        {
            // pokud je port otevřený
            if (serialPort1.IsOpen)
            {
                try
                {   // pokusí se ho zavřít                    
                    serialPort1.Close();                    // otevre
                    comboBox1.Enabled = true;
                    OCbtn.Text = "Otevřít";
                }
                catch
                {
                    MessageBox.Show("Nastala chyba při zavírání portu", "Chyba spojení", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            else // pokud je zavřený
            {
                try
                {   // pokusí se ho zavřít
                    serialPort1.PortName = comboBox1.Text;
                    serialPort1.BaudRate = 9600;
                    serialPort1.Open();
                    serialPort1.DiscardInBuffer();          // zahodi obsah bufferu
                    comboBox1.Enabled = false;
                    OCbtn.Text = "Close";
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Nastala chyba při otvírání portu:\n" + ex.Message, "Chyba spojení", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        // obsluha oznaceni tlacitek
        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            
            Graphics g = e.Graphics;
            Pen p = new Pen(Color.Green, 5);
            Pen p2 = new Pen(Color.LightGray, 5);
            // podle jednotlivych bitu vykresli prislusne kolecko u tlacitka
            if (btnArray[0]) g.DrawEllipse(p, 36, 4, 95, 95); else g.DrawEllipse(p2, 36, 4, 95, 95);        // STOP
            if (btnArray[1]) g.DrawEllipse(p, 208, 4, 95, 95); else g.DrawEllipse(p2, 208, 4, 95, 95);      // START
            if (btnArray[2]) g.DrawEllipse(p, 65, 107, 70, 70); else g.DrawEllipse(p2, 65, 107, 70, 70);    // F1
            if (btnArray[3]) g.DrawEllipse(p, 206, 107, 70, 70); else g.DrawEllipse(p2, 206, 107, 70, 70);  // F2
            if (btnArray[4]) g.DrawEllipse(p, 65, 197, 70, 70); else g.DrawEllipse(p2, 65, 197, 70, 70);    // F3
            if (btnArray[5]) g.DrawEllipse(p, 206, 197, 70, 70); else g.DrawEllipse(p2, 206, 197, 70, 70);  // F4
            if (btnArray[6]) g.DrawEllipse(p, 65, 285, 70, 70); else g.DrawEllipse(p2, 65, 285, 70, 70);    // F5
            if (btnArray[7]) g.DrawEllipse(p, 206, 286, 70, 70); else g.DrawEllipse(p2, 206, 286, 70, 70);  // F6

        }

        // invoking zmen na obrazku
        private void ZobrazZmeny(object s, EventArgs e)
        {
            // obnovi obrazek a s tim i oznaceni prislusnych tlacitek
            pictureBox1.Refresh();
            // vypise prijata data
            label2.Text = dataString;

            if (voltage != string.Empty)
                label4.Text = voltage + "V";
        }


        // zpracovani seriove komunikace
        private void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            
            byte data = new byte();
            // zjisti kolik dat je v bufferu
            int dLen = serialPort1.BytesToRead;
            
            // vybere cely buffer UARTU
            for (int i = 0; i < dLen; i++)
            {
                // vybere jeden byte
                data = (byte)serialPort1.ReadByte();

                // pokud jeste vramci bufferu nebyl zapsan start...
                if (zachycenStart == false)
                {
                    // pokud tam je hlavicka
                    if (data == (byte)0x02)
                    {
                        incSerialBuffer[0] = 0x02;      // ulozi hlavicku
                        bufferIndex = 1;                // nastavi ukazatel na druhy byte
                        zachycenStart = true;           // nastavi priznak za prijdou data
                        continue;                       // a pokracuje dalsim cyklem
                    }
                }
                else // pokud uz byl zachycen start
                {
                    incSerialBuffer[bufferIndex] = data;    // ulozi data
                    bufferIndex  +=1;                       // zvetsi ukazatel

                    //Debug.WriteLine(BitConverter.ToString(incSerialBuffer));

                    // pokud uz ma spravnou delku
                    if (bufferIndex == MbuffSize)
                    {
                        // zkontroluje jestli konci spravnym datem
                        if (incSerialBuffer[bufferIndex - 1] == (byte)0x0A)
                        {   // pokud ano
                            // oznami to
                            //Debug.WriteLine("Spravna delka i data");
                            //Debug.WriteLine(BitConverter.ToString(incSerialBuffer));

                            // zmeni bitove pole tlacitek
                            if ( (incSerialBuffer[2]&(byte)0x40) == (byte)0x40) btnArray[0] = true; else btnArray[0] = false;
                            if ( (incSerialBuffer[1]&(byte)0x01) == (byte)0x01) btnArray[1] = true; else btnArray[1] = false;
                            if ( (incSerialBuffer[2]&(byte)0x20) == (byte)0x20) btnArray[2] = true; else btnArray[2] = false;
                            if ( (incSerialBuffer[1]&(byte)0x02) == (byte)0x02) btnArray[3] = true; else btnArray[3] = false;
                            if ( (incSerialBuffer[2]&(byte)0x10) == (byte)0x10) btnArray[4] = true; else btnArray[4] = false;
                            if ( (incSerialBuffer[1]&(byte)0x04) == (byte)0x04) btnArray[5] = true; else btnArray[5] = false;
                            if ( (incSerialBuffer[2]&(byte)0x01) == (byte)0x01) btnArray[6] = true; else btnArray[6] = false;
                            if ( (incSerialBuffer[1]&(byte)0x20) == (byte)0x20) btnArray[7] = true; else btnArray[7] = false;

                            // prekonvertuje data pro potreby prvku label2
                            dataString = string.Empty;
                            Array.Copy(incSerialBuffer, 0, MBuffer, 0, MbuffSize);
                            dataString += BitConverter.ToString(MBuffer);

                            voltage = string.Empty;                            
                            // pokud jsou platna data o napeti baterie
                            if ((incSerialBuffer[3] & (byte)0x80) == (byte)0x80)
                            {
                                byte batVoltB = (byte)(incSerialBuffer[3] & (byte)0x0F);
                                double batVoltD= 2.25+ (float)batVoltB*0.1;
                                voltage = String.Format("{0:00.0}", batVoltD.ToString());
                                Debug.WriteLine("Napeti: " + voltage + "V");

                            }

                            // a vymaze data
                            Array.Clear(incSerialBuffer, 0, incSerialBuffer.Length);
                            zachycenStart = false;
                            bufferIndex = 0;
                        }
                        else // pokud ne
                        {
                            // oznami to
                            //Debug.WriteLine("Spravna delka ale spatna data");
                            //Debug.WriteLine(BitConverter.ToString(incSerialBuffer));
                            // a vymaze data
                            Array.Clear(incSerialBuffer, 0, incSerialBuffer.Length);
                            zachycenStart = false;
                            bufferIndex = 0;
                        }
                    }

                    continue;
                }

            }

            // zavola asynchonni prekresleni pictureBoxu
            this.BeginInvoke(new EventHandler(ZobrazZmeny));
        }

    }
}
